VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "  S4100 Utility"
   ClientHeight    =   7950
   ClientLeft      =   1590
   ClientTop       =   1890
   ClientWidth     =   7515
   Icon            =   "S4100_Main.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7950
   ScaleWidth      =   7515
   ShowInTaskbar   =   0   'False
   Begin MSCommLib.MSComm MSComm1 
      Left            =   960
      Top             =   240
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.Frame fra1 
      Height          =   6135
      Left            =   240
      TabIndex        =   0
      Top             =   1440
      Width           =   6855
      Begin VB.TextBox txtResponse 
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   3615
         Left            =   1200
         MultiLine       =   -1  'True
         TabIndex        =   11
         Top             =   1320
         Width           =   5295
      End
      Begin VB.TextBox txtRequest 
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   1680
         TabIndex        =   5
         Text            =   "0800030140"
         Top             =   600
         Width           =   3975
      End
      Begin VB.CommandButton cmdRead 
         BackColor       =   &H0080FFFF&
         Caption         =   "Send"
         Height          =   255
         Left            =   3120
         Style           =   1  'Graphical
         TabIndex        =   1
         Top             =   5520
         Width           =   975
      End
      Begin VB.Label Label2 
         Caption         =   "SOH"
         Height          =   255
         Left            =   1200
         TabIndex        =   10
         Top             =   240
         Width           =   375
      End
      Begin VB.Label lblData 
         Caption         =   "Data"
         Height          =   255
         Left            =   3240
         TabIndex        =   9
         Top             =   240
         Width           =   735
      End
      Begin VB.Label lblCSum 
         Caption         =   "LRC"
         Height          =   255
         Left            =   6000
         TabIndex        =   8
         Top             =   240
         Width           =   495
      End
      Begin VB.Label lblLRC 
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   1  'Fixed Single
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   5760
         TabIndex        =   7
         Top             =   600
         Width           =   735
      End
      Begin VB.Label lblStartByte 
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "01"
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   1200
         TabIndex        =   6
         Top             =   600
         Width           =   375
      End
      Begin VB.Label lblRequest 
         Caption         =   "Request"
         Height          =   255
         Left            =   240
         TabIndex        =   4
         Top             =   600
         Width           =   615
      End
      Begin VB.Label lblResponse 
         Caption         =   "Response"
         Height          =   255
         Left            =   240
         TabIndex        =   2
         Top             =   1440
         Width           =   855
      End
   End
   Begin VB.Image imgLogo 
      Height          =   870
      Left            =   1560
      Picture         =   "S4100_Main.frx":030A
      Stretch         =   -1  'True
      Top             =   240
      Width           =   4635
   End
   Begin VB.Label Label1 
      Caption         =   "About"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   495
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *******************************************************************************************************************
' *                                       Multi-Frequency Reader  Demo    V.1.0.0     (21 Dec  2002)                *
' *                                                                                                                                             *
' *      On loading, this program initialises Com port 1, in preparation for communicating with a          *
' *      Texas Instrument's Multi-Frequency (S4100) reader.                                                            *
' *      When "Send" is pressed, the hex command string is passed to the LCR routine.                   *
' *      The returned LRC ( with the SOH ) is assembled into the complete command string               *
' *      and is sent to the reader.    Any response from the reader is converted to hex and                 *
' *      checked and that response (or any rudimentory error information) displayed.                          *
' *                                                                                                                                             *
' *                                                                                                                                             *
' *     Originator:  J.A.G.      Copyright  Texas Instruments Ltd.   All Rights reserved                         *
' *******************************************************************************************************************

' Global variables
Public sCmdString As String                                              ' Hex string passed to checksum routine
Public sLRC As String                                                      ' LRC string returned by checksum routine

Option Explicit


Private Sub Form_Load()
    
     frmMain.MSComm1.CommPort = 1                                           ' Port 1 is Comm1
    frmMain.MSComm1.Settings = "9600,N,8,1"                             ' Setup Comm  parameters
    frmMain.MSComm1.PortOpen = True                                         ' Initialise Com port
    frmMain.Show
    frmMain.txtRequest.SetFocus

End Sub

Private Sub cmdRead_Click()
    ' Send command String to reader
    
    Dim Buffer As Variant                                                                      ' Response from MSComm
    Dim Aarray() As Byte                                                                      ' Array for response
    Dim i As Integer                                                                              ' Loop counter
    Dim nLength As Integer                                                                   ' Number of tags
    Dim nTemp As Integer                                                                     ' Temporary integer variable
    Dim lTemp1 As Long                                                                       ' Units
    Dim lTemp2 As Long                                                                       ' Tens
    Dim lTemp3 As Long                                                                       ' Thousands
    Dim sHexChars As String                                                                ' Temp variable for the hex conversion
    Dim sResponse As String                                                                ' Response string
    Dim sTemp As String                                                                      ' Temp string variable
    Dim lStartTime As Long                                                                   ' Timer variable
    Dim lTimeNow As Long                                                                    ' Timer variable
    Dim sTag As String                                                                          ' Reader response
    Dim HNibble As Byte                                                                       ' High nibble in hex conversion                                                                         '
    Dim LNibble As Byte                                                                        ' Low nibble in hex conversion
             
    On Error Resume Next                                                                    ' Catch any errors

    frmMain.cmdRead.Enabled = False                                                  ' Disable "Read" button
     
    Buffer = 0                                                                                        ' Clear variant
    sResponse = ""                                                                                ' Clear
    frmMain.txtResponse.Text = ""                                                          ' Clear Response box
    
     ' ****************** Assemble command  String********************
     
    sCmdString = frmMain.txtRequest.Text                                               ' Assign command string
    Call CheckLRC("01" & sCmdString, sLRC)                                           ' Calculate LCR Check Sum on all bytes
   
   ' Re-assemble Hex command string
    sTemp = "01" & sCmdString & sLRC                                                 ' Add start byte, data and CRC
    frmMain.lblLRC.Caption = sLRC
    sCmdString = ""                                                                               ' Re-initialise
    frmMain.txtResponse.Text = ""                                                          ' Clear Response text
    
    ' Convert Hex string to Binary string for output to reader
    For i = 1 To Len(sTemp) Step 2
        If Mid$(sTemp, i, 1) >= "A" And Mid$(sTemp, i, 1) <= "F" Then
            HNibble = (Asc(Mid$(sTemp, i, 1)) - 55) * 16
        Else
            HNibble = (Asc(Mid$(sTemp, i, 1)) - 48) * 16
        End If
        If Mid$(sTemp, i + 1, 1) >= "A" And Mid$(sTemp, i + 1, 1) <= "F" Then
            LNibble = (Asc(Mid$(sTemp, i + 1, 1)) - 55)
        Else
            LNibble = (Asc(Mid$(sTemp, i + 1, 1)) - 48)
        End If
        sCmdString = sCmdString & Chr$(HNibble + LNibble)                   ' Assemble complete string
    Next i
        
    sTemp = ""
    lStartTime = Timer                                                                            ' Initialise TIMEOUT timer
    frmMain.MSComm1.InBufferCount = 0                                                ' Clear the receive buffer
    frmMain.MSComm1.InputMode = comInputModeBinary                       ' Specify binary data input
    frmMain.MSComm1.InputLen = 6                                                       ' Input first 6 characters
    frmMain.MSComm1.Output = sCmdString                                          ' Send command to Reader
            
    ' Loop until characters are received or 1 second has elapsed
    Do Until frmMain.MSComm1.InBufferCount >= 6 Or lTimeNow > lStartTime + 4
        DoEvents                                                                                      ' Allow multitasking
        lTimeNow = Timer                                                                          ' Check time
    Loop
    
    ' Get response
    Buffer = frmMain.MSComm1.Input                                                      ' Assemble response
    Aarray = Buffer                                                                                 ' Assign Variant to Byte array
    nTemp = UBound(Aarray)                                                                  ' get length in bytes
'Stop

    If nTemp > 2 Then                                                                            ' Not TIMEOUT
         For i = 0 To (nTemp)                                                                   '  Convert  to Hex string
           sHexChars = Hex$(Aarray(i))
            If Len(sHexChars) = 1 Then                                                      '  Add "0" to single Hex chars
                sResponse = sResponse + ("0" & sHexChars)
            Else
                sResponse = sResponse + sHexChars
            End If
        Next i
        
        If Mid$(sResponse, 3, 1) >= "A" And Mid$(sResponse, 3, 1) <= "F" Then
            lTemp1 = (Asc(Mid$(sResponse, 3, 1)) - 55) * 16
        Else
            lTemp1 = (Asc(Mid$(sResponse, 3, 1)) - 48) * 16
        End If
        If Mid$(sResponse, 4, 1) >= "A" And Mid$(sResponse, 4, 1) <= "F" Then
            lTemp2 = (Asc(Mid$(sResponse, 4, 1)) - 55)
        Else
            lTemp2 = (Asc(Mid$(sResponse, 4, 1)) - 48)
        End If
        If Mid$(sResponse, 5, 1) >= "A" And Mid$(sResponse, 5, 1) <= "F" Then
            lTemp3 = (Asc(Mid$(sResponse, 6, 1)) - 55) * 256
        Else
            lTemp3 = (Asc(Mid$(sResponse, 6, 1)) - 48) * 256
        End If
      '  Get number of characters in complete response
       nLength = lTemp3 + lTemp1 + lTemp2
            
       lStartTime = Timer
       Buffer = ""
             
        'Set up MSComm to get rest (nLength - 6) of response.
            
        frmMain.MSComm1.InputLen = nLength - 6
        Do Until frmMain.MSComm1.InBufferCount >= (nLength - 6) Or lTimeNow > lStartTime + 1
            DoEvents
            lTimeNow = Timer
        Loop
        Buffer = frmMain.MSComm1.Input
        Aarray = Buffer
        nTemp = UBound(Aarray)
            
              
        For i = 0 To (nTemp)                                                    '  Convert  to Hex string
            sHexChars = Hex$(Aarray(i))
            If Len(sHexChars) = 1 Then                                                  ' Add extra "0" to single hex chars
                sResponse = sResponse + ("0" & sHexChars)
            Else
                sResponse = sResponse + sHexChars
            End If
        Next i
   
        Call CheckLRC(Left$(sResponse, Len(sResponse) - 4), sLRC)           ' Calculate LCR Check Sum on all bytes
        If (sLRC <> Right$(sResponse, 4)) Then                                           ' Is LRC OK?
            sTag = " Bad Checksum"
        ElseIf Mid$(sResponse, 7, 2) <> "03" Then                                        ' Check device type (03)
            sTag = " Bad Device  - " & Mid$(sResponse, 7, 2)
        ElseIf Mid$(sResponse, 13, 2) <> "00" Then                                        ' Check Error Flags
            Select Case Mid$(sResponse, 13, 2)
                Case Is = "01"
                    sTag = " No Token Found (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "02"
                     sTag = " Invalid Command 1 Value (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "03"
                    sTag = " Invalid Command  2 Value (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "04"
                     sTag = " Invalid RF Format (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "05"
                    sTag = " Entity Module Timeout (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "06"
                     sTag = " TBD (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "07"
                    sTag = " TBD (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "08"
                     sTag = " TBD (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "0E"
                    sTag = " Device ID Invalid (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "0F"
                     sTag = " TBD (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "10"
                    sTag = " Invalid Action Requested (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "11"
                     sTag = " Wrong Download Status (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "12"
                    sTag = " Write Failed (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "13"
                     sTag = " Invalid Address (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "14"
                    sTag = " Invalid Baud (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "15"
                     sTag = " Invalid Check Digits (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "1D"
                    sTag = " 14443 Packet Failure (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "1E"
                    sTag = " 14443 Configuration Data Invalid (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "20"
                     sTag = " 14443 Success (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "21"
                    sTag = " 14443 Write Failure (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "22"
                     sTag = " 14443 Write Timeout (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "23"
                    sTag = " 14443 Read Timeout (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "24"
                     sTag = " 14443 ATQB: Error Processing ATQB (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "25"
                    sTag = " 14443 ATQB: AID Invalid (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "26"
                     sTag = " 14443 ATQB: No. App. Field Invalid (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "27"
                    sTag = " 14443 ATQB: Bit Rate Capability Error (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "28"
                     sTag = " 14443 ATQB: Max Frame Size Error (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "29"
                    sTag = " 14443 ATQB: Protocol Type Invalid (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "2A"
                     sTag = " 14443 ATTRIB: Invalid MBLI (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "2B"
                    sTag = " 14443 Not An I-block (I-block Expected) (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "2C"
                     sTag = " 14443 Invalid CID (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "2D"
                    sTag = " 14443 Token Has Insufficient Power (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "2E"
                     sTag = " 14443 Not an R-block (R-block Expected) (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "2F"
                    sTag = " 14443 Not an S-block (S-block Expected) (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "30"
                     sTag = " 14443 Could Not Initialise SLF9000N FIFO (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "31"
                    sTag = " 14443 ATQB: ADC/FO error (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "32"
                     sTag = " 14443 Handle S(WTXM) block (Not An Error Code)  (" & Mid$(sResponse, 13, 2) & ")"
                Case Is = "33"
                     sTag = " Invalid RF Format  (" & Mid$(sResponse, 13, 2) & ")"
              Case Else
                    sTag = " Unknown error (" & Mid$(sResponse, 13, 2) & ")"
            End Select
        Else
            sTag = sResponse
        End If
    Else
        ' Timeout
        sTag = "Timeout - No response"                                                                    ' Timeout
    End If
        
    frmMain.txtResponse.Text = sTag                                             ' Display Tag ID/ error message
    cmdRead.Enabled = True                                                                   ' Re-enable "Send" button
    frmMain.txtRequest.SetFocus


End Sub

Private Sub Label1_Click()
     frmAbout.Show
End Sub


Private Sub txtRequest_GotFocus()
    frmMain.txtRequest.SelStart = Len(frmMain.txtRequest.Text)

End Sub
    

Private Sub txtRequest_KeyPress(KeyAscii As Integer)
    Dim sTemp As String
    Dim sTtemp As String
    
    
    sTemp = Str(KeyAscii)
    
    If (sTemp >= " 48" And sTemp <= " 57") Or (sTemp >= " 65" And sTemp <= " 70") Or sTemp = " 46" Or sTemp = " 8" Then
        KeyAscii = Val(sTemp)
    ElseIf sTemp >= " 97" Or sTemp <= " 102" Then
        KeyAscii = Val(sTemp) - 32
     ElseIf sTemp = " 13" Then
        frmMain.cmdRead.SetFocus
     Else
         KeyAscii = Asc(Chr(0))
    End If

End Sub

